/*====================================


	

	
=====================================*/
#include "STC8H.H"
#include "uart.h"
#include "modbus.h"
#include <string.h>
#include <stdio.h>


#define ET3         0x20
#define ET4					0x40
#define EX2         0x10
#define EX3         0x20
#define EX4         0x40

//-------ϵͳʱ
unsigned char bdata Sys_time;
sbit _1Sec_Temp=Sys_time^7;
sbit _500Ms_Temp=Sys_time^6;
sbit _100Ms_Temp=Sys_time^5;
sbit _10Ms_Temp=Sys_time^4;
sbit _1Sec_System=Sys_time^3;
sbit _500Ms_System=Sys_time^2;
sbit _100Ms_System=Sys_time^1;
sbit _10Ms_System=Sys_time^0;

sbit Led_power1 = P4^7;
sbit Led_power2 = P6^3;
sbit Bell = P2^1;
sbit Key_Gnd = P7^0;


bit Receive_flag,Ready_flag,Collect_flag,Quite_flag,Time_out_flag,Music_flag;
bit Study_mode,Sound_flag,Ram_bits6_temp,Rec_flag;
unsigned int Input_cnt,Ready_cnt,First_cnt,Quiet_cnt;
unsigned char Back_cnt,Err_cnt,Sound_cnt,Control_mode,RANGE;
unsigned int xdata Data_buf[200];
unsigned char Data_point,Dis_number,Music_step,Study_number,MAX;
unsigned int Time_real,Result;


unsigned int Study[10] = {0};
unsigned int Temp_buf[10] = {0};
unsigned char Study_cnt,Ready_cnt_set,Mode_temp,Rec_point;
//
unsigned char code Music[] = 		{3,3,5,6,8,8,6,5,5,6,5,
																3,3,5,6,8,8,6,5,5,6,5,
																5,5,5,3,5,6,6,5,
																3,2,3,5,3,2,1,1,2,1,
																3,2,1,3,2,3,5,6,8,5,
																2,3,5,2,3,1,20,19,
																20,1,2,3,
																1,2,1,20,19
																};
unsigned char code Music_time[] = 	{4,2,2,2,2,2,2,4,2,2,8,
																		4,2,2,2,2,2,2,4,2,2,8,
																		4,4,4,2,2,4,4,8,
																		4,2,2,4,2,2,4,2,2,8,
																		2,2,2,2,6,2,4,2,2,8,
																		4,2,2,2,2,2,2,8,
																		4,4,6,2,
																		2,2,2,2,16	
																	};
unsigned char code Reload_H[]={0,0x5b,0x6d,0x7d,0x84,0x91,0x9d,0xa8,0xad,0xb6,0xbe,0xc2,0xe0,0xed,0xde,0xd6,0xdb,0xdf};
unsigned char code Reload_L[]={0,0x26,0x09,0x1b,0x30,0xc1,0xd9,0x90,0x67,0x63,0x6C,0x23,0xc8,0xce,0x48,0xb3,0x32,0x41};																

unsigned char xdata Rec[50];


void Sys_init()
{
	Bell = 0;
	Key_Gnd = 0;
	P0M1 = 0x00;
	P0M0 = 0x00;
	P1M1 = 0x00;
	P1M0 = 0xff;
	P2M1 = 0x00;
	P2M0 = 0x02;
	P3M1 = 0x08;
	P3M0 = 0x00;
	P4M1 = 0x00;
	P4M0 = 0x80;
	P5M1 = 0x00;
	P5M0 = 0x00;
	P6M1 = 0x00;
	P6M0 = 0x08;
	P7M1 = 0x00;
	P7M0 = 0x00;
	
	Study_mode = 0;
	Input_cnt = 0;
	Receive_flag = 0;
	Ready_flag = 0;
	Ready_cnt = 100;
	Collect_flag = 0;
	Quite_flag = 0;
	Quiet_cnt = 0;
	Back_cnt = 0;
	Data_point = 0;
	Time_out_flag = 0;
	Err_cnt = 0;
	First_cnt = 100;
	Music_step = 0;
	Music_flag = 0;
	Study_number = 0;
	Sound_flag = 0;
	Sound_cnt = 0;
	Control_mode = 1;
	Mode_temp = 1;
	RAM_WORDS[11] = 6;
	RAM_WORDS[14] = 200;
	Ready_cnt_set = 100;
	Ram_bits6_temp = 0;
	Rec_flag = 0;
	
}

void Timer0Init(void)		//1ms@22.1184MHz
{
	AUXR |= 0x80;		//ʱʱ1Tģʽ
	TMOD &= 0xF0;		//öʱģʽ
	TL0 = 0x9A;				//öʱʼֵ
	TH0 = 0xA9;				//öʱʼֵ
	TF0 = 0;		//TF0־
	TR0 = 1;		//ʱ0ʼʱ
	ET0 = 1;
}

void Timer3_Init(void)		//1ms@22.1184MHz
{
	T4T3M &= 0xFD;			//ʱʱ12Tģʽ
	T3L = 0;				
	T3H = 0;	
	T4T3M |= 0x08;			//ʱ3ʼʱ
	IE2 |= ET3;
}

void Timer4_Init(void)		//1000΢@22.1184MHz
{
	T4T3M |= 0x20;			//ʱʱ1Tģʽ
	T4L = 0x5C;				//öʱʼֵ
	T4H = 0xF7;				//öʱʼֵ
	T4T3M |= 0x80;			//ʱ4ʼʱ
	IE2 |= ET4;
}

void Int_init()
{
  IT1 = 1;                    //INT0ж (1:½ 0:غ½)
  EX1 = 1;                    //ʹINT0ж		
}

void SysTimer_start_Process(void)
{
	if(_10Ms_System == 1)
		Sys_time = Sys_time<<4;
}

void SysTimer_end_Process(void)
{
	Sys_time = Sys_time & 0x0f;
}

void RAM_init()
{
	RAM_WORDS[0] = Control_mode;
	RAM_WORDS[10] = 1;
	RAM_WORDS[11] = RANGE;
	RAM_WORDS[12] = 1;
	RAM_WORDS[14] = 150;

}

void RAM_Process()
{
	unsigned long sum;
	unsigned char i;
	
	Control_mode = RAM_WORDS[0];
	RAM_WORDS[1] = Dis_number;
	RAM_WORDS[2] = Temp_buf[0];
	RAM_WORDS[3] = Temp_buf[1];
	RAM_WORDS[4] = Temp_buf[2];
	RAM_WORDS[5] = Study[0];
	RAM_WORDS[6] = Study[1];
	RAM_WORDS[7] = Study[2];
	RAM_WORDS[8] = Study[3];
	RAM_WORDS[9] = Study[4];	
	
	RANGE = RAM_WORDS[11];
	Study_number = RAM_WORDS[10];
	Study_cnt = RAM_WORDS[12];
	RAM_WORDS[13] = Result;
	MAX = RAM_WORDS[14];
	
	RAM_BITS[0] = Study_mode;
	
	if(RAM_BITS[1])		//ѧϰģʽ
		{
			RAM_BITS[1] = 0;
			Study_mode = !Study_mode;
			if(Study_mode)
				{
					Study_number = 1;
					Study_cnt = 0;
					for(i=0;i<10;i++)
					{
						Temp_buf[i] = 0;
					}
				}
		}	
	if(RAM_BITS[2])		//ѧϰȷ
		{
			RAM_BITS[2] = 0;
			if(Study_mode)
				{					
					Temp_buf[Study_cnt-1] = Result;
					RAM_WORDS[12]++;
				}
		}
	if(RAM_BITS[4])		//ѧϰ浽洢
		{
			RAM_BITS[4] = 0;
			sum = 0;
			for(i=0;i<Study_cnt-1;i++)
			{
				sum = sum + Temp_buf[i];
			}							
			Study[Study_number-1] = sum/(Study_cnt-1);	
			RAM_WORDS[12] = 1;	
			for(i=0;i<10;i++)
			{
				Temp_buf[i] = 0;
			}			
			RAM_WORDS[10]++;
			if(RAM_WORDS[10] >= 10) RAM_WORDS[10] = 1;	
		}
	if(RAM_BITS[5])		//¼
		{
			RAM_BITS[5] = 0;
			for(i=0;i<10;i++)
			{
				Study[i] = 0;
			}
			RAM_WORDS[10] = 1;
		}
	RAM_BITS[3] = Collect_flag;
	
	if(RAM_BITS[6] && Ram_bits6_temp==0)
		{
			Rec_point = 0;
		}
	Ram_bits6_temp = RAM_BITS[6];
	
	if(RAM_BITS[7])
		{
			RAM_BITS[7] = 0;
			Rec_flag = 1;
			Music_step = 0;
			T4T3M |= 0x20;			//ʱʱ1Tģʽ
			T4L = Reload_L[Rec[0]];				//öʱʼֵ
			T4H = Reload_H[Rec[0]];				//öʱʼֵ
			T4T3M |= 0x80;			//ʱ4ʼʱ
		}
}

void Run_Process()
{
	unsigned char i;
	unsigned long sum;
	
	if(Control_mode == 1 && Mode_temp !=1)
		{
			RAM_WORDS[11] = 6;
			RAM_WORDS[14] = 200;
			Ready_cnt_set = 100;
		}
	if(Control_mode == 2 && Mode_temp !=2)
		{
			RAM_WORDS[11] = 12;
			RAM_WORDS[14] = 150;
			Ready_cnt_set = 60;
		}
	if(Control_mode == 3 && Mode_temp !=3)
		{
			RAM_WORDS[11] = 25;
			RAM_WORDS[14] = 120;
			Ready_cnt_set = 60;
		}
	if(Control_mode == 4 && Mode_temp !=4)
		{
			RAM_WORDS[11] = 20;
			RAM_WORDS[14] = 120;
			Ready_cnt_set = 60;
		}
	Mode_temp = Control_mode;
	
	if(Receive_flag)
		{
			Receive_flag = 0;
			
			sum = 0;
			for(i=0;i<MAX;i++)
			{
				sum = sum + Data_buf[i];
				Result = sum/MAX;
			}
			
			if(Study_mode)
				{
					Temp_buf[Study_cnt-1] = Result;
					Study_cnt++;
				}
			else
				{
					if(Control_mode == 1)		//ж1,3,5
						{
							if(Result >= Study[0] - RANGE && Result <= Study[0] + RANGE)
								{
									Dis_number = 1;
								}
							else if(Result >= Study[2] - RANGE && Result <= Study[2] + RANGE)
								{
									Dis_number = 3;
								}
							else if(Result >= Study[4] - RANGE && Result <= Study[4] + RANGE)
								{
									Dis_number = 5;
								}
						}
					else if(Control_mode == 2)	//ж2,4,5
						{
							if(Result >= Study[1] - RANGE && Result <= Study[1] + RANGE)
								{
									Dis_number = 2;
									T4T3M |= 0x20;			//ʱʱ1Tģʽ
									T4L = Reload_L[2];				//öʱʼֵ
									T4H = Reload_H[2];				//öʱʼֵ
									T4T3M |= 0x80;			//ʱ4ʼʱ
									IE2 |= ET4;	
									Sound_flag = 1;
								}
							else if(Result >= Study[3] - RANGE && Result <= Study[3] + RANGE)
								{
									Dis_number = 4;
									T4T3M |= 0x20;			//ʱʱ1Tģʽ
									T4L = Reload_L[4];				//öʱʼֵ
									T4H = Reload_H[4];				//öʱʼֵ
									T4T3M |= 0x80;			//ʱ4ʼʱ
									IE2 |= ET4;	
									Sound_flag = 1;
								}
							else if(Result >= Study[4] - RANGE && Result <= Study[4] + RANGE)
								{
									Dis_number = 5;
									T4T3M |= 0x20;			//ʱʱ1Tģʽ
									T4L = Reload_L[5];				//öʱʼֵ
									T4H = Reload_H[5];				//öʱʼֵ
									T4T3M |= 0x80;			//ʱ4ʼʱ
									IE2 |= ET4;	
									Sound_flag = 1;
								}
						}
					else if(Control_mode == 3)
						{
							if(Result >= Study[0] - RANGE && Result <= Study[0] + RANGE)
								{
									Dis_number = 1;
									T4T3M |= 0x20;			//ʱʱ1Tģʽ
									T4L = Reload_L[1];				//öʱʼֵ
									T4H = Reload_H[1];				//öʱʼֵ
									T4T3M |= 0x80;			//ʱ4ʼʱ
									IE2 |= ET4;	
									Sound_flag = 1;
									
									if(RAM_BITS[6])
										{
											Rec[Rec_point] = 1;
											Rec_point++;
										}
								}
							else if(Result >= Study[1] - RANGE && Result <= Study[1] + RANGE)
								{
									Dis_number = 2;
									T4T3M |= 0x20;			//ʱʱ1Tģʽ
									T4L = Reload_L[2];				//öʱʼֵ
									T4H = Reload_H[2];				//öʱʼֵ
									T4T3M |= 0x80;			//ʱ4ʼʱ
									IE2 |= ET4;	
									Sound_flag = 1;
									if(RAM_BITS[6])
										{
											Rec[Rec_point] = 2;
											Rec_point++;
										}
								}
							else if(Result >= Study[2] - RANGE && Result <= Study[2] + RANGE)
								{
									Dis_number = 3;
									T4T3M |= 0x20;			//ʱʱ1Tģʽ
									T4L = Reload_L[3];				//öʱʼֵ
									T4H = Reload_H[3];				//öʱʼֵ
									T4T3M |= 0x80;			//ʱ4ʼʱ
									IE2 |= ET4;	
									Sound_flag = 1;
									if(RAM_BITS[6])
										{
											Rec[Rec_point] = 3;
											Rec_point++;
										}
								}
							else if(Result >= Study[3] - RANGE && Result <= Study[3] + RANGE)
								{
									Dis_number = 4;
									T4T3M |= 0x20;			//ʱʱ1Tģʽ
									T4L = Reload_L[4];				//öʱʼֵ
									T4H = Reload_H[4];				//öʱʼֵ
									T4T3M |= 0x80;			//ʱ4ʼʱ
									IE2 |= ET4;	
									Sound_flag = 1;
									if(RAM_BITS[6])
										{
											Rec[Rec_point] = 4;
											Rec_point++;
										}
								}
							else if(Result >= Study[4] - RANGE && Result <= Study[4] + RANGE)
								{
									Dis_number = 5;
									T4T3M |= 0x20;			//ʱʱ1Tģʽ
									T4L = Reload_L[5];				//öʱʼֵ
									T4H = Reload_H[5];				//öʱʼֵ
									T4T3M |= 0x80;			//ʱ4ʼʱ
									IE2 |= ET4;	
									Sound_flag = 1;
									if(RAM_BITS[6])
										{
											Rec[Rec_point] = 5;
											Rec_point++;
										}
								}
						}
					else if(Control_mode == 4)
						{
							if(Result >= Study[0] - RANGE && Result <= Study[0] + RANGE)
								{
									Dis_number = 1;
								}
							else if(Result >= Study[1] - RANGE && Result <= Study[1] + RANGE)
								{
									Dis_number = 2;
								}
							else if(Result >= Study[2] - RANGE && Result <= Study[2] + RANGE)
								{
									Dis_number = 3;
								}
							else if(Result >= Study[3] - RANGE && Result <= Study[3] + RANGE)
								{
									Dis_number = 4;
								}
							else if(Result >= Study[4] - RANGE && Result <= Study[4] + RANGE)
								{
									Dis_number = 5;
								}
							else 
								{
									Dis_number = 0;
								}								
						}
				
				}
		}
	
//	Run_led = !Collect_flag;
	
	if(_10Ms_Temp)
		{
			if(Ready_cnt > 0)
				{
					Ready_cnt--;
					if(Ready_cnt == 0)
						{
							Collect_flag = 1;
						}
				}	
			if(First_cnt > 0)
				{
					First_cnt--;
					if(First_cnt == 0)
						{
							Music_flag = 1;
							Music_step = 0;
							T4T3M |= 0x20;			//ʱʱ1Tģʽ
							T4L = Reload_L[Music[Music_step]];				//öʱʼֵ
							T4H = Reload_H[Music[Music_step]];				//öʱʼֵ
							T4T3M |= 0x80;			//ʱ4ʼʱ
							IE2 |= ET4;							
							
						}
				}			
		}

}

void main()
{
	MODBUS_Init();
	Sys_init();
	RAM_init();
	Timer0Init();
	Int_init();
	Uart1Init();
	Timer3_Init();
	
	
	EA = 1;
	
	WDT_CONTR = 0x04;       //20M      : 0.63s
	WDT_CONTR |= 0x20;      //Ź
	
	while(1)
		{
			WDT_CONTR |= 0x10; 			//㿴Źʱ			
			SysTimer_start_Process();
			
			Run_Process();
			Modbus_Process();
			RAM_Process();

			SysTimer_end_Process();
		}
}

void SysTick_Handler(void)
{
	static unsigned int Timer_cnt=0;
	Timer_cnt++;
	if(0==(Timer_cnt%10)) _10Ms_System=1;
	if(0==(Timer_cnt%100)) _100Ms_System=1;
	if(0==(Timer_cnt%500)) _500Ms_System=1;
	if(1000==Timer_cnt)
	{
		Timer_cnt=0;
		_1Sec_System=1;
	}		
}

void INT1_Isr() interrupt 2
{
	if(Collect_flag)
		{
			T4T3M &= ~0x08;			//ʱ3ֹͣʱ
			if(Time_out_flag)
				{
					Time_out_flag = 0;
					Data_point = 0;
					Err_cnt = 0;
				}
			else
				{
					Time_real = T3H;
					Time_real = (Time_real<<8) + T3L;	
					if(Time_real > 900 && Time_real < 2000)
						{
							Data_buf[Data_point] = Time_real;
							Data_point++;
							if(Data_point >= MAX)
								{
									Data_point = 0;
									Receive_flag = 1;
									Err_cnt = 0;
									Collect_flag = 0;
									Ready_cnt = Ready_cnt_set;
								}
						} 
					else
						{
							Err_cnt++;
							if(Err_cnt > 10)
								{
									Err_cnt = 0;
									Data_point = 0;
								}
						}						
				}
			T3L = 0;				
			T3H = 0;				
			T4T3M |= 0x08;			//ʱ3ʼʱ			
		}
}

void Timer0Interrupt(void) interrupt 1        //1ms
{
	static unsigned int cnt=0;
	UART1_ReceiveOvertimeProcess();
	SysTick_Handler();
	
	if(Music_flag)
		{
			cnt++;
			if(cnt >= Music_time[Music_step]*208)
				{
					cnt = 0;
					Music_step++;
					if(Music_step >= 22)
						{
							Music_step = 0;
							Music_flag = 0;
							T4T3M &= ~0x80;
							Bell = 0;
						}
					else
						{
							T4T3M &= ~0x80;
							Bell = 0;
							T4L = Reload_L[Music[Music_step]];				//öʱʼֵ
							T4H = Reload_H[Music[Music_step]];				//öʱʼֵ
							T4T3M |= 0x80;			//ʱ4ʼʱ							
						}
				}
		}
	if(Rec_flag)
		{
			cnt++;
			if(cnt >= 800)
				{
					cnt = 0;
					Music_step++;
					if(Music_step >= Rec_point)
						{
							Music_step = 0;
							Rec_flag = 0;
							T4T3M &= ~0x80;
							Bell = 0;
						}
					else
						{
							T4T3M &= ~0x80;
							Bell = 0;
							T4L = Reload_L[Rec[Music_step]];				//öʱʼֵ
							T4H = Reload_H[Rec[Music_step]];				//öʱʼֵ
							T4T3M |= 0x80;			//ʱ4ʼʱ	
						}
				}
		}
	if(Sound_flag)
		{
			cnt++;
			if(cnt >= 800)
				{
					cnt = 0;
					Sound_flag = 0;
					T4T3M &= ~0x80;
					Bell = 0;
				}
		}

}

void TM3_Isr() interrupt 19
{	
	Time_out_flag = 1;	
}

void TM4_Isr() interrupt 20 
{
	Bell = !Bell;

}