#include "STC8G.h"
#include "uart.h"



volatile unsigned char xdata UART1_receive_buf[BUFLEN];//
volatile unsigned char xdata UART1_ready_buf[BUFLEN];  //
volatile unsigned char xdata UART1_send_buf[BUFLEN];   //
volatile unsigned char xdata UART1_receivetimecounter = 0; //
volatile unsigned char xdata UART1_receive_index=0;        
volatile unsigned char xdata UART1_ready_buf_ok = 0;       //
volatile unsigned char xdata UART1_ready_buf_len = 0;
volatile unsigned char xdata UART1_send_index=0;           //
volatile unsigned char xdata UART1_send_len=0;
volatile unsigned char *UART1_send_point;

unsigned char cnt7f = 0;

void Uart1Init(void)		//115200bps@22.1184MHz
{
//    P_SW1 = 0x00;                               //RXD/P3.0, TXD/P3.1
  P_SW1 |= 0x40;                               //RXD_2/P3.6, TXD_2/P3.7
//  P_SW1 |= 0x80;                               //RXD_3/P1.6, TXD_3/P1.7
//  P_SW1 |= 0xc0;                               //RXD_4/P4.3, TXD_4/P4.4
	SCON = 0x50;		//8λ,ɱ䲨
	AUXR |= 0xE0;		//ʱ1ʱΪFosc,1T
	AUXR &= 0xFE;		//1ѡʱ1Ϊʷ
	TMOD &= 0x0F;		//趨ʱ1Ϊ16λԶװʽ
	TL1 = 0xD0;			//öʱʼֵ
	TH1 = 0xFF;			//öʱʼֵ
	ET1 = 0;		//ֹʱ1ж
	TR1 = 1;		//ʱ1
	ES = 1;
	UART1_send_point = UART1_send_buf;
}

void Uart1_ISR(void) interrupt 4
{
   if(TI) 
		{
			TI=0;
			if(UART1_send_index < UART1_send_len)
				{
					SBUF=*(UART1_send_point + UART1_send_index);
					UART1_send_index++;				
				}
		}
   if(RI)
    {
			RI=0;
			UART1_receive_buf[UART1_receive_index++]=SBUF;
			if(UART1_receive_index>=BUFLEN) UART1_receive_index=0;  
			UART1_receivetimecounter=OVERTIME;
			if(SBUF == 0x7f)
				{
					if(++cnt7f == 8) IAP_CONTR = 0x60;
				}
			else 
				{
					cnt7f = 0;
				}			
    }
}

void UART1_ReceiveOvertimeProcess(void)
{
	unsigned char xdata i = 0;	

	if(UART1_receivetimecounter>0)
	{
		UART1_receivetimecounter--;
		if(UART1_receivetimecounter<=0)
		{
			UART1_ready_buf_len = UART1_receive_index;
			for(i = 0;i <= UART1_ready_buf_len; i ++)
				UART1_ready_buf[i] = UART1_receive_buf[i];
			UART1_ready_buf_ok = 1;
			UART1_receive_index=0;
		}
	}
}

